package phuturewarez.bacon;

import java.io.File;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import phuturewarez.bacon.EventHooks;
import phuturewarez.bacon.config.ConfigHandler;
import phuturewarez.bacon.items.AddedItems;
import phuturewarez.bacon.items.CookedBacon;
import phuturewarez.bacon.items.RawBacon;
import phuturewarez.bacon.lib.Reference;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.stats.Achievement;
import net.minecraft.stats.AchievementList;
import net.minecraft.util.RegistryNamespaced;
import cpw.mods.fml.client.event.ConfigChangedEvent;
import cpw.mods.fml.common.FMLCommonHandler;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.SidedProxy;
import cpw.mods.fml.common.Mod.EventHandler;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import cpw.mods.fml.common.registry.GameData;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.registry.LanguageRegistry;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.common.config.Configuration;
import net.minecraftforge.common.config.Property;

@Mod(name = Reference.MOD_NAME, modid = Reference.MOD_ID, version = Reference.MOD_VER, useMetadata = true, guiFactory = "phuturewarez.bacon.config.GUIFactory")
public class BaconMain {

	// The instance of the mod that Forge uses
    @Instance(value = Reference.MOD_ID)
    public static BaconMain instance;
	public static Configuration config;
    public static final String modId = Reference.MOD_ID;
    public static Achievement bringBacon;
	public static Logger log = LogManager.getLogger("Bacon");
    
    @EventHandler
    public void preInit(FMLPreInitializationEvent event) {
    	config = new Configuration(event.getSuggestedConfigurationFile());
    	config.load();
    	ConfigHandler.syncConfig();
        AddedItems.initItems();
    	bringBacon = new Achievement("bacon.bringbacon", "BringBacon", 5, -4, AddedItems.rawBacon, AchievementList.buildSword).registerStat();
        GameRegistry.addSmelting(AddedItems.rawBacon, new ItemStack(AddedItems.cookedBacon), 0.8F);
    }
       
    @EventHandler
    public void load(FMLInitializationEvent event) {
        MinecraftForge.EVENT_BUS.register(new EventHooks());
        FMLCommonHandler.instance().bus().register(new FMLEventHooks());
    }
       
    @EventHandler
    public void postInit(FMLPostInitializationEvent event) {
        // Stub Method
    }

}